% PP_parser/pp_lang2_pp.ml                                                    %
%-----------------------------------------------------------------------------%


let pp_lang2_rules =

   % : (print_rule list) %

   letrec quote_quote = (\dummy0. ((\s. letrec dupl s sl =
                                           if (null sl)
                                           then []
                                           else if ((hd sl) = s)
                                                then s.s.(dupl s (tl sl))
                                                else (hd sl).(dupl s (tl sl))
                                        in (implode o (dupl s) o explode)
                                    ) dummy0))
   and destruct =
    (\dummy0. ((\ptaddl.
                   map (\(pt,add).
                           case pt
                           of (Print_node (s,[])) . (s,add)
                            | (_) . failwith `pp_lang_rules_fun`) ptaddl
                ) dummy0))
   and construct =
    (\dummy0. ((\saddl. map (\(s,add). Print_node (s,[]),add) saddl) dummy0))
   and convert =
    (\dummy0.
       ((\saddl.
            if ((length saddl) = 1)
            then [(trim_enclosing_chars [` `] # I) (hd saddl)]
            else if ((trim_enclosing_chars [` `] (fst (hd saddl))) = ``)
                 then let saddl' =
                         map (trim_trailing_chars [` `] # I) saddl
                      in  let dead_space =
                             min (map (num_of_leading_chars [` `])
                                         (filter (\s. not (s = ``))
                                             (map fst saddl')))
                          in  map (\(s,add).
                                      if (s = ``)
                                      then (s,add)
                                      else (substr dead_space
                                               ((strlen s) - dead_space)
                                                  s,add)) saddl'
                 else failwith `pp_lang_rules_fun`
         ) dummy0))
   and is_char =
    (\dummy0. ((\(l,c,u). not (((ascii_code c) < (ascii_code l)) or
                                  ((ascii_code c) > (ascii_code u)))
                ) dummy0))
   and is_ucase = (\dummy0. ((\c. is_char (`A`,c,`Z`)) dummy0))
   and is_lcase = (\dummy0. ((\c. is_char (`a`,c,`z`)) dummy0))
   and is_letter = (\dummy0. ((\c. (is_ucase c) or (is_lcase c)) dummy0))
   and is_digit = (\dummy0. ((\c. is_char (`0`,c,`9`)) dummy0))
   and is_underscore = (\dummy0. ((\c. mem c [`_`]) dummy0))
   and is_id_body =
    (\dummy0. ((\sl. if (null sl)
                     then true
                     else if (is_underscore (hd sl))
                          then if (null (tl sl))
                               then false
                               else if (is_letter (hd (tl sl))) or
                                          (is_digit (hd (tl sl)))
                                    then is_id_body (tl (tl sl))
                                    else false
                          else if (is_letter (hd sl)) or (is_digit (hd sl))
                               then is_id_body (tl sl)
                               else false
                ) dummy0))
   and not_id = (\dummy0. (((\sl. if (null sl)
                                  then true
                                  else if (is_letter (hd sl))
                                       then not (is_id_body (tl sl))
                                       else true) o explode
                            ) dummy0))
   and is_keyword =
    (\dummy0. ((\s. mem s
                     [`prettyprinter`;`rules`;`declarations`;`abbreviations`;
                      `with`;`end`;`where`;`if`;`then`;`else`;
                      `h`;`v`;`hv`;`hov`]
                ) dummy0))
   in
   [
    ((``,(Const_name (`INT_EXP`,[(Patt_child (Var_child `int_exp`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`int_exp`,(I)),[])))])));
    ((``,
      (Const_name
        (`ASSIGN`,
         [(Patt_child (Var_child `id`));(Patt_child (Var_child `exp`))])),
      (\x y. true)),[],
     (PF
       (HV_box [(((Nat 1),(Abs 3),(Nat 0)),
                 (PO_format
                   (PF (H_box [((Nat 1),(PO_subcall ((`id`,(I)),[])));
                               ((Nat 1),(PO_constant `:=`))]))));
                (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`exp`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`ASSIGNMENTS`,
               [(Patt_child (Var_child `assigns`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`ASSIGNMENTS`,[(Patt_child (Var_child `assign`))])))),
      (\x y. true)),[],
     (PF (HoV_box
           [(((Nat 1),(Abs 0),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_subcall ((`assigns`,(I)),[])));
                       ((Nat 0),(PO_constant `;`))])));
            (((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`assign`,(I)),[])))])));
    ((``,(Const_name (`F_SUBCALL`,[(Patt_child (Var_child `child`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`child`,(I)),[])))])));
    ((``,(Const_name (`F_SUBCALL`,[(Patt_child (Var_child `transform`));
                                   (Patt_child (Var_child `metavar`))])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 0),(Abs 3),(Nat 0)),(PO_subcall ((`transform`,(I)),[])));
            (((Nat 0),(Abs 3),(Nat 0)),
             (PO_format
               (PF (H_box [((Nat 0),(PO_constant `(`));
                           ((Nat 0),(PO_subcall ((`metavar`,(I)),[])));
                           ((Nat 0),(PO_constant `)`))]))))])));
    ((``,(Const_name (`C_SUBCALL`,[(Patt_child (Var_child `f_subcall`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`f_subcall`,(I)),[])))])));
    ((``,(Const_name (`C_SUBCALL`,[(Patt_child (Var_child `string`));
                                   (Patt_child (Var_child `f_subcall`))])),
      (\x y. true)),[],
     (PF
       (HV_box
         [(((Nat 0),(Abs 3),(Nat 0)),
           (PO_format
             (PF (H_box [((Nat 0),(PO_subcall ((`string`,(I)),[])));
                         ((Nat 0),(PO_constant `::`))]))));
          (((Nat 0),(Abs 3),(Nat 0)),(PO_subcall ((`f_subcall`,(I)),[])))])));
    ((``,
      (Const_name
        (`LEAF_OR_SUBCALL`,
         [(Patt_child (Var_child `c_subcall`));(Var_children `assigns`)])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`c_subcall`,(I)),[])));
            (((Nat 1),(Abs 3),(Nat 0)),
             (PO_expand
               (V_box
                 [(((Abs 0),(Nat 0)),(PO_constant `with`));
                  (((Abs 3),(Nat 0)),(PO_subcall ((`assigns`,(I)),[])));
                  (((Abs 0),(Nat 0)),(PO_constant `end with`))])))])));
    ((``,(Const_name (`INC`,[(Patt_child (Var_child `num`))])),(\x y. true)),
     [],(PF (H_box [((Nat 0),(PO_constant `+`));
                    ((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,(Const_name (`H_PARAMS`,[(Patt_child (Var_child `num`))])),
      (\x y. true)),[],(PF (H_box [((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,(Const_name (`V_PARAMS`,[(Patt_child (Var_child `indent`));
                                  (Patt_child (Var_child `num`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`indent`,(I)),[])));
                 ((Nat 0),(PO_constant `,`));
                 ((Nat 0),(PO_subcall ((`num`,(I)),[])))])));
    ((``,(Const_name (`HV_PARAMS`,[(Patt_child (Var_child `num1`));
                                   (Patt_child (Var_child `indent`));
                                   (Patt_child (Var_child `num2`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`num1`,(I)),[])));
                 ((Nat 0),(PO_constant `,`));
                 ((Nat 0),(PO_subcall ((`indent`,(I)),[])));
                 ((Nat 0),(PO_constant `,`));
                 ((Nat 0),(PO_subcall ((`num2`,(I)),[])))])));
    ((``,(Const_name (`HOV_PARAMS`,[(Patt_child (Var_child `num1`));
                                    (Patt_child (Var_child `indent`));
                                    (Patt_child (Var_child `num2`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`num1`,(I)),[])));
                 ((Nat 0),(PO_constant `,`));
                 ((Nat 0),(PO_subcall ((`indent`,(I)),[])));
                 ((Nat 0),(PO_constant `,`));
                 ((Nat 0),(PO_subcall ((`num2`,(I)),[])))])));
    ((``,(Const_name (`H_BOX`,[(Patt_child (Var_child `h_params`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 1),(PO_constant `h`));
                 ((Nat 1),(PO_subcall ((`h_params`,(I)),[])))])));
    ((``,(Const_name (`V_BOX`,[(Patt_child (Var_child `v_params`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 1),(PO_constant `v`));
                 ((Nat 1),(PO_subcall ((`v_params`,(I)),[])))])));
    ((``,(Const_name (`HV_BOX`,[(Patt_child (Var_child `hv_params`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 1),(PO_constant `hv`));
                 ((Nat 1),(PO_subcall ((`hv_params`,(I)),[])))])));
    ((``,(Const_name (`HOV_BOX`,[(Patt_child (Var_child `hov_params`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 1),(PO_constant `hov`));
                 ((Nat 1),(PO_subcall ((`hov_params`,(I)),[])))])));
    ((``,(Const_name (`OBJECT`,[(Patt_child (Var_child `object`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_subcall ((`object`,(I)),[])))])));
    ((``,
      (Const_name
        (`H_OBJECT`,
         [(Var_children `h_params`);(Patt_child (Var_child `object`))])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 1),(Abs 3),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_constant `<`));
                       ((Nat 0),(PO_subcall ((`h_params`,(I)),[])));
                       ((Nat 0),(PO_constant `>`))])));
            (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`object`,(I)),[])))])));
    ((``,
      (Const_name
        (`V_OBJECT`,
         [(Var_children `v_params`);(Patt_child (Var_child `object`))])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 1),(Abs 3),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_constant `<`));
                       ((Nat 0),(PO_subcall ((`v_params`,(I)),[])));
                       ((Nat 0),(PO_constant `>`))])));
            (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`object`,(I)),[])))])));
    ((``,
      (Const_name
        (`HV_OBJECT`,
         [(Var_children `hv_params`);(Patt_child (Var_child `object`))])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 1),(Abs 3),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_constant `<`));
                       ((Nat 0),(PO_subcall ((`hv_params`,(I)),[])));
                       ((Nat 0),(PO_constant `>`))])));
            (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`object`,(I)),[])))])));
    ((``,
      (Const_name
        (`HOV_OBJECT`,
         [(Var_children `hov_params`);(Patt_child (Var_child `object`))])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 1),(Abs 3),(Nat 0)),
             (PO_expand
               (H_box [((Nat 0),(PO_constant `<`));
                       ((Nat 0),(PO_subcall ((`hov_params`,(I)),[])));
                       ((Nat 0),(PO_constant `>`))])));
            (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`object`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`H_OBJECT_LIST`,
               [(Patt_child (Var_child `h_objects`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`H_OBJECT_LIST`,[(Patt_child (Var_child `h_object`))])))),
      (\x y. true)),[],
     (PF (HoV_box
           [(((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`h_objects`,(I)),[])));
            (((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`h_object`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`V_OBJECT_LIST`,
               [(Patt_child (Var_child `v_objects`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`V_OBJECT_LIST`,[(Patt_child (Var_child `v_object`))])))),
      (\x y. true)),[],
     (PF (HoV_box
           [(((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`v_objects`,(I)),[])));
            (((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`v_object`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`HV_OBJECT_LIST`,
               [(Patt_child (Var_child `hv_objects`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`HV_OBJECT_LIST`,[(Patt_child (Var_child `hv_object`))])))),
      (\x y. true)),[],
     (PF
       (HoV_box
         [(((Nat 1),(Abs 0),(Nat 0)),
           (PO_subcall ((`hv_objects`,(I)),[])));
          (((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`hv_object`,(I)),[])))])));
    ((``,
      (Print_loop
        ((Const_name
           (`HOV_OBJECT_LIST`,
            [(Patt_child (Var_child `hov_objects`));
             (Patt_child (Link_child ((Default,Default),[])))])),
         (Const_name
           (`HOV_OBJECT_LIST`,[(Patt_child (Var_child `hov_object`))])))),
      (\x y. true)),[],
     (PF
       (HoV_box
         [(((Nat 1),(Abs 0),(Nat 0)),
           (PO_subcall ((`hov_objects`,(I)),[])));
          (((Nat 1),(Abs 0),(Nat 0)),(PO_subcall ((`hov_object`,(I)),[])))])));
    ((``,
      (Const_name (`BOX_SPEC`,[(Patt_child (Var_child `box`));
                               (Patt_child (Var_child `object_list`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `<`));
                 ((Nat 0),(PO_subcall ((`box`,(I)),[])));
                 ((Nat 0),(PO_constant `>`));
                 ((Nat 1),(PO_subcall ((`object_list`,(I)),[])))])));
    ((``,(Const_name (`EXPAND`,[(Patt_child (Var_child `box_spec`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `**[`));
                 ((Nat 0),(PO_subcall ((`box_spec`,(I)),[])));
                 ((Nat 0),(PO_constant `]`))])));
    ((``,(Const_name (`FORMAT`,[])),(\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `[]`))])));
    ((``,(Const_name (`FORMAT`,[(Patt_child (Var_child `box_spec`))])),
      (\x y. true)),[],
     (PF (H_box [((Nat 0),(PO_constant `[`));
                 ((Nat 0),(PO_subcall ((`box_spec`,(I)),[])));
                 ((Nat 0),(PO_constant `]`))])));
    ((``,(Const_name (`FORMAT`,[(Patt_child (Var_child `test`));
                                (Patt_child (Var_child `format1`));
                                (Patt_child (Var_child `format2`))])),
      (\x y. true)),[],
     (PF
       (HoV_box
         [(((Nat 1),(Abs 0),(Nat 0)),
           (PO_format
             (PF (H_box [((Nat 1),(PO_constant `if`));
                         ((Nat 1),(PO_subcall ((`test`,(I)),[])))]))));
          (((Nat 1),(Abs 0),(Nat 0)),
           (PO_format
             (PF (H_box [((Nat 1),(PO_constant `then`));
                         ((Nat 1),(PO_subcall ((`format1`,(I)),[])))]))));
          (((Nat 1),(Abs 0),(Nat 0)),
           (PO_format
             (PF (H_box [((Nat 1),(PO_constant `else`));
                         ((Nat 1),(PO_subcall ((`format2`,(I)),[])))]))))])));
    ((``,(Const_name
           (`RULE`,[(Patt_child
                      (Const_name
                        (`PATTERN`,[(Patt_child (Var_child `string`));
                                    (Patt_child (Var_child `patt_tree`));
                                    (Var_children `test`)])));
                    (Var_children `p_specials`);
                    (Patt_child (Var_child `format`))])),(\x y. true)),[],
     (PF
       (H_box [((Nat 0),(PO_subcall ((`string`,(I)),[])));
               ((Nat 0),(PO_constant `::`));
               ((Nat 0),
                (PO_format
                  (PF
                    (HoV_box [(((Nat 1),(Abs 0),(Nat 0)),
                               (PO_format
                                 (PF (H_box
                                       [((Nat 1),
                                         (PO_format
                                           (PF (HV_box
                                                 [(((Nat 1),(Abs 3),
                                                    (Nat 0)),
                                                   (PO_subcall
                                                     ((`patt_tree`,
                                                       (I)),[])));
                                                  (((Nat 1),(Abs 3),
                                                    (Nat 0)),
                                                   (PO_expand
                                                     (HV_box
                                                       [(((Nat
                                                            1),
                                                          (Abs
                                                            3),
                                                          (Nat 0)),
                                                         (PO_constant
                                                           `where`));
                                                        (((Nat 1),
                                                          (Abs 3),
                                                          (Nat 0)),
                                                         (PO_subcall
                                                           ((`test`,
                                                             (I)),
                                                            [])))])))]))));
                                        ((Nat 1),(PO_constant `->`))]))));
                              (((Nat 1),(Abs 0),(Nat 0)),
                               (PO_expand
                                 (H_box
                                   [((Nat 1),(PO_constant `<<`));
                                    ((Nat 1),
                                     (PO_subcall ((`p_specials`,(I)),[])));
                                    ((Nat 1),(PO_constant `>>`))])));
                              (((Nat 1),(Abs 0),(Nat 0)),
                               (PO_subcall ((`format`,(I)),[])))]))))])));
    ((``,(Print_loop
           ((Const_name
              (`RULE_LIST`,
               [(Patt_child (Var_child `rules`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name (`RULE_LIST`,[(Patt_child (Var_child `rule`))])))),
      (\x y. true)),[],
     (PF (V_box [(((Abs 0),(Nat 1)),
                  (PO_expand
                    (H_box [((Nat 0),(PO_subcall ((`rules`,(I)),[])));
                            ((Nat 0),(PO_constant `;`))])));
                 (((Abs 0),(Nat 1)),
                  (PO_format
                    (PF (H_box [((Nat 0),(PO_subcall ((`rule`,(I)),[])));
                                ((Nat 0),(PO_constant `;`))]))))])));
    ((``,(Const_name (`RULES`,[(Patt_child (Var_child `rule_list`))])),
      (\x y. true)),[],
     (PF (V_box [(((Abs 3),(Nat 0)),(PO_constant `rules`));
                 (((Abs 3),(Nat 0)),(PO_subcall ((`rule_list`,(I)),[])));
                 (((Abs 0),(Nat 1)),(PO_constant `end rules`))])));
    ((``,(Const_name (`BINDING`,[(Patt_child (Var_child `id`));
                                 (Patt_child (Var_child `ml_fun`))])),
      (\x y. true)),[],
     (PF (HV_box
           [(((Nat 1),(Abs 3),(Nat 0)),
             (PO_format
               (PF (H_box [((Nat 1),(PO_subcall ((`id`,(I)),[])));
                           ((Nat 1),(PO_constant `=`))]))));
            (((Nat 1),(Abs 3),(Nat 0)),(PO_subcall ((`ml_fun`,(I)),[])))])));
    ((``,(Print_loop
           ((Const_name
              (`BINDING_LIST`,
               [(Patt_child (Var_child `bindings`));
                (Patt_child (Link_child ((Default,Default),[])))])),
            (Const_name
              (`BINDING_LIST`,[(Patt_child (Var_child `binding`))])))),
      (\x y. true)),[],
     (PF (V_box [(((Abs 0),(Nat 1)),
                  (PO_expand
                    (H_box [((Nat 0),(PO_subcall ((`bindings`,(I)),[])));
                            ((Nat 0),(PO_constant `;`))])));
                 (((Abs 0),(Nat 1)),
                  (PO_format
                    (PF (H_box [((Nat 0),(PO_subcall ((`binding`,(I)),[])));
                                ((Nat 0),(PO_constant `;`))]))))])));
    ((``,
      (Const_name (`DECLARS`,[(Patt_child (Var_child `binding_list`))])),
      (\x y. true)),[],
     (PF (V_box [(((Abs 3),(Nat 0)),(PO_constant `declarations`));
                 (((Abs 3),(Nat 0)),(PO_subcall ((`binding_list`,(I)),[])));
                 (((Abs 0),(Nat 1)),(PO_constant `end declarations`))])));
    ((``,
      (Const_name (`ABBREVS`,[(Patt_child (Var_child `binding_list`))])),
      (\x y. true)),[],
     (PF (V_box [(((Abs 3),(Nat 0)),(PO_constant `abbreviations`));
                 (((Abs 3),(Nat 0)),(PO_subcall ((`binding_list`,(I)),[])));
                 (((Abs 0),(Nat 1)),(PO_constant `end abbreviations`))])));
    ((``,(Const_name (`BODY`,[(Var_children `x`)])),(\x y. true)),[],
     (PF (V_box [(((Abs 0),(Nat 2)),(PO_subcall ((`x`,(I)),[])))])));
    ((``,
      (Const_name
        (`PP`,
         [(Patt_child (Var_child `id`));(Patt_child (Var_child `body`))])),
      (\x y. true)),[],
     (PF (V_box [(((Abs 0),(Nat 1)),
                  (PO_format
                    (PF (H_box [((Nat 1),(PO_constant `prettyprinter`));
                                ((Nat 1),(PO_subcall ((`id`,(I)),[])));
                                ((Nat 1),(PO_constant `=`))]))));
                 (((Abs 0),(Nat 1)),(PO_subcall ((`body`,(I)),[])));
                 (((Abs 0),(Nat 2)),(PO_constant `end prettyprinter`))])))
   ] : print_rule list;;


let pp_lang2_rules_fun =

   % : (print_rule_function) %

   print_rule_fun pp_lang2_rules;;


%-----------------------------------------------------------------------------%
